'use strict';

var GanttChartController = angular.module('GanttChartController', []);

GanttChartController.controller('GanttChartCtrl', ['$scope', '$filter', 'Construcao', 'CacheApp',
  ($scope, $filter, Construcao, CacheApp) => {
    $scope.construcao = {};

    $scope.construcao = CacheApp.getConstrucao();
    $scope.dataInicio = new Date($scope.construcao.DataInicio);
    $scope.dataFim = new Date($scope.construcao.DataFim);

    var tempoRestante = Math.abs($scope.dataFim - $scope.dataInicio);
    $scope.dias = Math.ceil(tempoRestante / (1000 * 3600 * 24))+2;

    $scope.getListaDias = () => {
        $scope.listaDias = [];
        for (var i=0;i<$scope.dias-1;i++) {
            var dia = new Date($scope.construcao.DataInicio);
            dia.setDate(dia.getDate() + i);
            $scope.listaDias.push(dia);
        }
    }

    $scope.getPlanejaEtapa = () => {
        $scope.getListaDias();
        $scope.TotalMedicao = 0;
        Construcao.getPlanejaEtapa($scope.construcao.Id,
            (data) => {
                $scope.etapas = data.Instance;
                $scope.Medicoes = [];

                var idxMain = -1;
                var countSub = 0;
                for (var i in $scope.etapas) {
                    var etapa = $scope.etapas[i];

                    etapa.QtdDiasInicio = etapa.QtdDiasInicio ? etapa.QtdDiasInicio : 0;;
                    var ini = etapa.QtdDiasInicio;

                    etapa.QtdDiasExecucao = etapa.QtdDiasExecucao ? etapa.QtdDiasExecucao : 0;
                    var fim = !etapa.Medicoes[etapa.Medicoes.length-1] ? 0 : etapa.Medicoes[etapa.Medicoes.length-1].QtdDiasInicio + etapa.Medicoes[etapa.Medicoes.length-1].QtdDiasExecucao;
 
                    etapa.DataInicio = new Date($scope.construcao.DataInicio);
                    etapa.DataInicio.setDate(etapa.DataInicio.getDate() + ini);

                    etapa.DataFim = new Date($scope.construcao.DataInicio);
                    etapa.DataFim.setDate(etapa.DataFim.getDate() + fim-(etapa.Medicoes.length > 0 ? 1 : 0));

                    if (etapa.Ordem.indexOf('.') < 0) {
                        idxMain = i;
                        countSub = 0;
                    }
                    if (etapa.Ordem.indexOf($scope.etapas[idxMain].Ordem+'.') == 0) {
                        if(countSub == 0)
                            $scope.etapas[idxMain].DataInicio = etapa.DataInicio;
                        if($scope.etapas[idxMain].DataInicio > etapa.DataInicio)
                            $scope.etapas[idxMain].DataInicio = etapa.DataInicio;
                        if($scope.etapas[idxMain].DataFim < etapa.DataFim)
                            $scope.etapas[idxMain].DataFim = etapa.DataFim;
                        countSub++;
                    }

                    for (var j in etapa.Medicoes) {
                        var medicao = etapa.Medicoes[j];
                        medicao.QtdDiasInicio = medicao.QtdDiasInicio ? medicao.QtdDiasInicio : 0;;
                        var iniM = medicao.QtdDiasInicio;
    
                        medicao.QtdDiasExecucao = medicao.QtdDiasExecucao ? medicao.QtdDiasExecucao : 0;
                        var fimM = medicao.QtdDiasInicio + medicao.QtdDiasExecucao;
     
                        medicao.DataInicio = new Date($scope.construcao.DataInicio);
                        medicao.DataInicio.setDate(medicao.DataInicio.getDate() + iniM);
    
                        medicao.DataFim = new Date($scope.construcao.DataInicio);
                        medicao.DataFim.setDate(medicao.DataFim.getDate() + fimM-1);
                    }
                }

                $scope.table = $scope.getHtmlTable();
            });
    }
    $scope.getPlanejaEtapa();


    $scope.getHtmlTable = () => {
        var table = '' + 
        '    <table class="table tableoff"> ' + 
        '    <thead> ' + 
        '        <tr class="row tr-fonteTitulo"> ' + 
        '            <th>Etapa</th> ' + 
        '            <th>Início</th> ' + 
        '            <th>Fim</th> ' + 
        '            <th>Duração</th> ' + 
        '            <th ng-repeat="item in listaDias">{{item | date:\'dd/MM\'}}</th> ' + 
        '        </tr> ' + 
        '    </thead> ' + 
        '    <tbody>';
        for (var i in $scope.etapas) {
            var item = $scope.etapas[i];
            var textoPopover = 'De ' + $filter('date')(item.DataInicio,'dd/MM/yyyy') + ' até ' + $filter('date')(item.DataFim,'dd/MM/yyyy') + '. Dia: {{dia | date:\'dd/MM\'}} ';
            table +=
            '<tr class="row tr-fonteItem">' +
                '<td>' + item.Ordem + ' ' + item.Etapa + '</td>' + 
                '<td>' + $filter('date')(item.DataInicio,'dd/MM/yyyy') + '</td>' +
                '<td>' + $filter('date')(item.DataFim,'dd/MM/yyyy') + '</td>' +
                '<td>' + (item.QtdDiasExecucao - item.QtdDiasInicio) + '</td>' + 
                '<td ng-repeat="dia in listaDias" ng-style="validaData(etapas[' + i + '].Medicoes,dia) && {\'background-color\': \'#263143\'}"><div data-placement="left" data-content="'+ textoPopover +'" rel="popover" data-original-title="'+item.Etapa+'" data-trigger="hover" style="cursor: default">&nbsp;&nbsp;&nbsp;&nbsp;<div></td>' +
                // '<td ng-repeat="dia in listaDias" ng-style="validaData(\''+$filter('date')(item.DataInicio,'yyyy-MM-ddT00:05:00Z')+'\',\''+$filter('date')(item.DataFim,'yyyy-MM-ddT00:05:00Z')+'\',dia,'+item.QtdDiasExecucao+') && {\'background-color\': \'#263143\'}"><div data-placement="left" data-content="'+ textoPopover +'" rel="popover" data-original-title="'+item.Etapa+'" data-trigger="hover" style="cursor: default">&nbsp;&nbsp;&nbsp;&nbsp;<div></td>' +
            '</tr>';
        }
        table += '</tbody></table>';

        setTimeout(function() {
            $('[rel = "popover"]').popover();
        }, 100);
        
        return table;
    }      

    $scope.validaData = function(medicoes, dia) {
        var result = false;
        for (var i in medicoes) {
            var medicao = medicoes[i];
            if (new Date(medicao.DataInicio) <= dia && dia <= new Date(medicao.DataFim) && medicao.QtdDiasExecucao > 0) {
                result = true;
                break;
            }
        }
        return result;
    }

  }]);
